#include <QApplication>
#include <QImage>
#include <QPainter>
#include <QTextDocument>
#include <QAbstractTextDocumentLayout>
#include <QDebug>
#include <QLoggingCategory>

void logCharFormat(const QTextCharFormat TCF, QString what)
{
   qDebug() << what;
   #if (QT_VERSION >= QT_VERSION_CHECK(5, 13, 0)) 
   qDebug() << "font families " << TCF.fontFamilies() ;
#endif
   qDebug() << "font familie " << TCF.fontFamily();
   qDebug() << "font " << TCF.font();
   qDebug() << " ";
}

int main(int argc, char* argv[])
{
   //QLoggingCategory::setFilterRules("*.debug=true\n"
   //   "qt.qpa.fonts.debug=true");

   qDebug() << "Qt Version " << qVersion();
   QApplication app(argc, argv);
   QTextDocument theText;
   theText.setHtml(
      "<!DOCTYPE HTML PUBLIC \" -//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\"> \
      <html><head><meta name = \"qrichtext\" content = \"1\" /><style type = \"text/css\"> \
      p, li{ white - space: pre - wrap; } \
      </style></head><body style = \" font-family:'Sans Serif'; font-size:9pt; font-weight:400; font-style:normal;\"> \
      <p align = \"center\" style = \" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><span style = \" font-family:'Fibel Nord Zebra'; font-size:18pt; color:#ffffaa;\">Text</span></p></body> </html>"
   );
   QTextCursor Cursor;
   Cursor = theText.find("Text", Cursor);
   //qDebug() << Cursor.position();
   Cursor.select(QTextCursor::WordUnderCursor);
   //qDebug() << Cursor.selectedText();

   QTextCharFormat TCF;
   TCF.setFontFamily("Arial");
   //#if (QT_VERSION >= QT_VERSION_CHECK(5, 13, 0)) 
   //   TCF.setFontFamilies(QStringList("Arial"));
   //#endif
   if (Cursor.hasSelection())
   {
      logCharFormat(Cursor.charFormat(), "before merge:");
      Cursor.mergeCharFormat(TCF);
      logCharFormat(Cursor.charFormat(), "after merge:");
   }
   qDebug() << "resulting HTML:";
   QString theHTML = theText.toHtml();
   qDebug() << theHTML;
   int spanBegin = theHTML.lastIndexOf("<span");
   int spanEnd = theHTML.lastIndexOf("</p");
   qDebug() << "relevant HTML-Part:";
   qDebug() << theHTML.mid(spanBegin, spanEnd - spanBegin);
   qDebug() << "\n\n";
}
